﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using Infragistics.Windows.DataPresenter;
using System.Diagnostics;

namespace xamDataGridFieldLayoutsInitialized
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        int br = 0;
        List<int> levels = new List<int>();

        public MainWindow()
        {
            InitializeComponent();

            foreach (var record in xamDataGrid1.Records)
            {
                levels.Add(MainWindow.RecordLevels(0, record));
            }
        }

        private void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            
            Dispatcher.BeginInvoke(new Action(() =>
            {
                br++;
                if (br == (levels.Max() + 1))
                {
                    //add code to be executed after last fieldlayout initialized
                    Debug.WriteLine("Last Initialized");
                }
            }), System.Windows.Threading.DispatcherPriority.Background, null);

            
            //br++;
            //if (br == 2)//2 = number of data levels
            //{
            //    MessageBox.Show("Last FieldLayout is going to initialize!");
            //}
            
        }

        public static int RecordLevels(int i,  Record record)
        {

            if ((record as DataRecord).HasChildren)
            {
                ExpandableFieldRecordCollection children = (record as DataRecord).ChildRecords;
                foreach (var child in children)
                {
                    if ((child as ExpandableFieldRecord).HasChildren)
                        return RecordLevels(++i, child.ChildRecords[i] as Record);

                }
                return i;
            }
            else
                return i;
        }
    }
}
